#define STOP_ITER 1000000000
#define CACHE_LINE_SIZE 8
#define PROC_NUM 8


int main(){
  long flags[PROC_NUM][CACHE_LINE_SIZE];
  long localSum[PROC_NUM][CACHE_LINE_SIZE];
  long progress[PROC_NUM][CACHE_LINE_SIZE];
  long counters[PROC_NUM][CACHE_LINE_SIZE];
  long progress1,progress2;
  long sum,i,k,j;
  int loop;
  double glr,localR;
  long *remoteFlag=flags[0],*localFlag=flags[2];
  printf("\n\nRemote Access Penalty\n%d processors %d iterations %d byte spacing between the local variables of each thread\n",
      PROC_NUM, STOP_ITER, CACHE_LINE_SIZE * sizeof(long));

  for (loop=0; loop<100; loop++){
  counters[0][0]=counters[1][0]=counters[2][0]=0; 
  localSum[0][0]=localSum[1][0]=localSum[2][0]=0;
  flags[0][0]=flags[1][0]=flags[2][0]=-1;
  parblock
  { /* local undisturbed */
  //  long i=0;
    for (i=0; i<STOP_ITER;i++){
      localSum[0][0]+= (*remoteFlag)==1?-2:0;
      (*remoteFlag)=-1;
      progress[0][0]=i;
    }
  }:
  {
 //   long j=0;
    for (j=0; j<STOP_ITER; j++){
      localSum[1][0]+= (*remoteFlag)==-1?-2:0;
      (*remoteFlag)=1;
      progress[1][0]=j;
    }
  }:
  {
   // long k=0;
    for (k=0; k<STOP_ITER; k++){
       localSum[2][0]+=((*localFlag)*1)-1;
       (*localFlag)=-1;
       progress[2][0]=k;
    }

    sum=(localSum[0][0]+localSum[1][0])/-2;
    progress1=progress[0][0];
    progress2=progress[1][0];
    printf("Remote Access: %.2lf%%\n",100.*sum/(progress2+progress1));
    printf("progress 1: %.2lf%% ; progress 2: %.2lf%% progress 3: 100%%\n",(100.*progress1)/STOP_ITER,(100.*progress2)/STOP_ITER);
    localR=((100.*progress1)/STOP_ITER+(100.*progress2)/STOP_ITER)/2;
    localR=localR-(100.*sum/(STOP_ITER*2));
    glr=(100-localR)/(100.*sum/(STOP_ITER*2));
    printf("Global to Local Rate: %.2lf \n",glr);

  }:{}:{}:{}:{}:{}
    
  }
  return 0;
}
