#define CACHE_LINE_SIZE 8
#define PROC_NUM 8
#define ARR_SIZE 500000
#define STOP_ITER ARR_SIZE

int main(){
  long flags[PROC_NUM][CACHE_LINE_SIZE];
  long progress[PROC_NUM][CACHE_LINE_SIZE];
  long remoteArr[ARR_SIZE];
  long localArr[ARR_SIZE];
  long progress1,progress2;
  long sum;
  int loop;
  double glr,localR;
  long i=0,j=0,k=0;
  long *remoteFlag=flags[0],*localFlag=flags[2];
  printf("\n\nShared Write Penalty\n%d processors %d iterations %d byte spacing between the local variables of each thread\n",
      PROC_NUM, STOP_ITER, CACHE_LINE_SIZE * sizeof(long));

  for (loop=0; loop<5; loop++){
  
  flags[0][0]=flags[1][0]=flags[2][0]=-1;
  parblock
  { /* global access */
    for (i=1; i<ARR_SIZE-1; i++){
	remoteArr[i+1]=(remoteArr[i]+i)%i;
    }
  }:
  { /* global access */
    for (j=1; j<ARR_SIZE-1; j++){
	remoteArr[j+1]=(remoteArr[j]+j)%j;
    }
  }:
  { /* local access */ 
    for (k=1; k<ARR_SIZE-1; k++){
	localArr[k+1]=(localArr[k]+k)%k;
    }

    progress1=i+1;
    progress2=j+1;
    printf("progress 1: %.2lf%% ; progress 2: %.2lf%% progress 3: 100%%\n",(100.*progress1)/STOP_ITER,(100.*progress2)/STOP_ITER,(100.*progress[2][0])/STOP_ITER);
    glr=k/((progress1+progress1)/2.);
    printf("Global to Local Rate: %.2lf \n",glr);
    

  }:{}:{}:{}:{}:{}
    
  }
  return 0;
}