#define STOP_ITER 1000000000
#define CACHE_LINE_SIZE 8
#define PROC_NUM 8


int main(){
  long flags[PROC_NUM][CACHE_LINE_SIZE];
  long progress[PROC_NUM][CACHE_LINE_SIZE];
  long progress1,progress2;
  long sum;
  int loop;
  double glr,localR;
  long i=0,j=0,k=0;
  long *remoteFlag=flags[0],*localFlag=flags[2];
  printf("\n\nShared Write Penalty\n%d processors %d iterations %d byte spacing between the local variables of each thread\n",
      PROC_NUM, STOP_ITER, CACHE_LINE_SIZE * sizeof(long));

  flags[0][0]=flags[1][0]=flags[2][0]=-1;
  parblock
  { /* global access */
    for (i=0; i<STOP_ITER; i++){
      (*remoteFlag)=0;
      while (*remoteFlag==0);
    }
  }:
  { /* global access */
    for (j=0; j<STOP_ITER; j++){
      (*remoteFlag)=1;
      while (*remoteFlag==1);
    }
  }:
  { /* local access */ 
    for (k=0; k<STOP_ITER; k++){
       (*localFlag)=k;
       progress[2][0]=k;
    }

    progress1=i;
    progress2=j;
    printf("progress 1: %.2lf%% ; progress 2: %.2lf%% progress 3: 100%%\n",(100.*progress1)/STOP_ITER,(100.*progress2)/STOP_ITER,(100.*progress[2][0])/STOP_ITER);
    glr=progress[2][0]/((progress1+progress1)/2.);
    printf("Global to Local Rate: %.2lf \n",glr);
    exit(0);
  }:{}:{}:{}:{}:{}
    
  
  return 0;
}