#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include <pthread.h>
#include "globals.h"

#if defined (_MSC_VER)|| defined(WINDOWS) || defined(__CYGWIN__)
#include <windows.h>
#endif

int setThreadAffMask(int newMask){

		#if defined (_MSC_VER)|| defined(WINDOWS) || defined(__CYGWIN__)
			return SetThreadAffinityMask(GetCurrentThread(), 1<<newMask)!=0;
		#else
			  cpu_set_t mask;
			  unsigned int len = sizeof(mask);
			  CPU_ZERO(&mask);
			  CPU_SET(newMask,&mask);
			  return sched_setaffinity(0, len, &mask);
		#endif
}

void setThreadAff(int processor){
	setThreadAffMask(processor-1);
}

int getThreadAffMask(){
		#if defined (_MSC_VER)|| defined(WINDOWS) || defined(__CYGWIN__)
			return 0;
		//	return SetThreadAffinityMask(GetCurrentThread(), newMask)!=0;
		#else
			  int affiliatedCPU=0;
			  cpu_set_t mask;
			  unsigned int len = sizeof(mask);
			  sched_getaffinity(0, len, &mask);
			  while (affiliatedCPU<=procnum){
				  if (CPU_ISSET(affiliatedCPU,&mask))
					  return affiliatedCPU;
				  affiliatedCPU++;
			  }

			return 0;
		#endif
}
