#include "time.h"

#define CACHE_LINE_SIZE 8
#define PROC_NUM 8
#define STOP_ITER 100000000
#define local 	localCounter[i][0]++;
#define global 	globalCounter[i][0]++;
#define Duplicate5(instr)	instr instr instr instr instr
#define Duplicate10(instr)	Duplicate5(instr) Duplicate5(instr)
#define Duplicate20(instr)	Duplicate10(instr) Duplicate10(instr)
#define Duplicate40(instr)	Duplicate20(instr) Duplicate20(instr)
#define Duplicate60(instr)	Duplicate40(instr) Duplicate20(instr)
#define Duplicate80(instr)	Duplicate40(instr) Duplicate40(instr)
#define Duplicate120(instr)	Duplicate80(instr) Duplicate40(instr)
#define Duplicate240(instr)	Duplicate120(instr) Duplicate120(instr)


int main(){
int y=0,x=0;
int i=0,j=0;
long localI[PROC_NUM][CACHE_LINE_SIZE];
long globalCounter[PROC_NUM][1];
long localCounter[PROC_NUM][CACHE_LINE_SIZE];
clock_t before,after;

printf("warming up\n");
before=clock();

parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		local
	;}
;}
after=clock();
printf("warm up time: %ld\n",after-before);

before=clock();

parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		local
	;}
;}
after=clock();
printf("local time  1: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		global
	;}

;}
after=clock();
printf("global time 1: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate5(local)
		local
	;}
;}
after=clock();
printf("local time  2: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate5(local)
		global
		
	;}

;}
after=clock();
printf("global time 2: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate10(local)
		local
	;}
;}
after=clock();
printf("local time  3: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate10(local)
		global
	;}

;}
after=clock();
printf("global time 3: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate20(local)
		local
	;}
;}
after=clock();
printf("local time  4: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate20(local)
		global
	;}

;}
after=clock();
printf("global time 4: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate40(local)
		local
	;}
;}
after=clock();
printf("local time  5: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate40(local)
		global
	;}

;}
after=clock();
printf("global time 5: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate60(local)
		local
	;}
;}
after=clock();
printf("local time  6: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate60(local)
		global
	;}

;}
after=clock();
printf("global time 6: %ld\n",after-before);


before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate80(local)
		local
	;}
;}
after=clock();
printf("local time  7: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate80(local)
		global
	;}

;}
after=clock();
printf("global time 7: %ld\n",after-before);


before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate120(local)
		local
	;}
;}
after=clock();
printf("local time  8: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate120(local)
		global
	;}

;}
after=clock();
printf("global time 8: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate240(local)
		local
	;}
;}
after=clock();
printf("local time  9: %ld\n",after-before);

before=clock();
parfor (i=0; i<8; i++){
	for (localI[i][0]=0;localI[i][0]<STOP_ITER;localI[i][0]++){
		Duplicate240(local)
		global
	;}

;}
after=clock();
printf("global time 9: %ld\n",after-before);

}

