#include <Thread.h>
#include <stdio.h>
#include <time.h>
#include <pthread.h>
#include <pth.h>

void *Thread::thread_func(void *d){
	if (((Thread *)d)->toRun)
		((Thread *)d)->toRun->run();
	else
		((Runnable *)d)->run();
	return d;
}


int Thread::start(){
			return pthread_create(&thread, NULL, Thread::thread_func, (void*)this);
}

void Thread::setPJ(ParJoin *_pj){
		pj=_pj;
		if (toRun)
			toRun->pj=_pj;
}
void Thread::run(){
	if (toRun)
		toRun->run();
}

int Thread::wait(){
		return pthread_join(thread, NULL);
}
int Thread::join(){
		return pthread_join(thread, NULL);
}
Thread::Thread(Runnable *whatToRun):toRun(whatToRun){}
Thread::Thread(Runnable *whatToRun, ParJoin *_pj):toRun(whatToRun){
	whatToRun->pj=_pj;
	pj=_pj;
}
Thread::Thread():toRun(NULL){}
