#include <Thread.h>
#include <stdio.h>
#include <time.h>
#include <pthread.h>
#include <ProcessorsManager.h>
#define WINDOWS
#include <mypthreads.h>

static pthread_key_t key;
static pthread_once_t key_once = PTHREAD_ONCE_INIT;

static void make_key(){(void) pthread_key_create(&key, NULL);}

int a(int localCounter){
	void* ptr=NULL;
	printf("key %x\n",&key);
	(void) pthread_once(&key_once, make_key);
	if ((ptr = pthread_getspecific(key)) == NULL) {
		int *x=new int();
		*x=localCounter;
	  (void) pthread_setspecific(key, x);
	  return *x;
	}
	return *(int*)ptr;
}

class B: public Runnable{
public:
	B(){

	}
public:
	void run(){
		 printf("B \n");
	}
};

class A: public Runnable{
	static int counter;
	int localCounter;
public:
	A(){
		localCounter=counter++;
	}
public:

	void run(){
		 int x=a(localCounter+10);
		 printf("thread number: %x\n",pthread_self());
		 printf("A %d\n",a(localCounter+1));
		 printf("A %d\n",a(localCounter+2));
		 printf("A %d\n",a(localCounter+3));
		 printf("A %d\n",a(localCounter+4));
	}
};
int A::counter=0;
int main(void){

/*	ProcessorsManager *pm=ProcessorsManager::getInstance();
	ProcessingUnit *pu=pm->getProcessor(0);
	for (int i=0; i<10000; i++){
		pu=pm->getProcessor(i);
		pu->execute(new A());
	}
	pm->join();
 */

	Thread a1(new A());
	Thread a2(new A());
	Thread a3(new A());
//	Thread bb(new B());
	a1.start();
	a2.start();
	a3.start();

	a1.join();
	a2.join();
	a3.join();

	return 0;
}
