#ifndef USERTHREAD_H

#define USERTHREAD_H

#include "Thread.h"
#include <stdio.h>
#include <time.h>
#include "pth.h"
#include <pthread.h>

/** userThread will be user to wrap PTh */
class UserThread : public Thread {
	public:
		pth_t thread;
		UserThread();
		UserThread(Runnable *whatToRun);
		UserThread(Runnable *whatToRun,ParJoin *_pj);
		virtual void run(){
			if (toRun)
				toRun->run();
			};
		virtual int start();
		virtual int wait();
		virtual int join();
		Runnable *toRun;
};

#endif
