#include <Thread.h>
#include <stdio.h>
#include <time.h>
#include <pthread.h>
#include <ProcessorsManager.h>
#define WINDOWS
#include <pth.h>
#include <mypthreads.h>
#include <semaphore.h>
#include <ParJoin.h>
class A: public Runnable{
	static int a;
	static int counter;
	int localCounter;
public:
	A(){
	}
public:

	void run(){
		localCounter=counter;
		a=counter;
		counter=a+1;
		 printf("pthread number: %x\n",pthread_self());
		 printf("pth thread number: %x\n",pth_self());
		 printf("local counter %d, global counter: %d\n",localCounter,counter);

		signalFinished();
	}
};
int A::counter=0;
int A::a=0;
int main(void){
	ParJoin pj(4);
	ProcessorsManager *pm=ProcessorsManager::getInstance();
	ProcessingUnit *pu=pm->getProcessor(0);
	for (int i=0; i<4; i++){
		pu=pm->getProcessor(i);
		A *a=new A();
		a->pj=&pj;
		pu->execute(a);
	}
	pj.join();

	return 0;
}
