#include <Thread.h>
#include <stdio.h>
#include <time.h>
#include <ProcessorsManager.h>
#define WINDOWS
#include <mypthreads.h>
class A: public Runnable{
	static int counter;
	int localCounter;
public:
	A(){
		localCounter=counter++;
	}
public:
	void run(){
		 printf("A %d\n",localCounter);
	}
};
int A::counter=0;
int main(void){

	ProcessorsManager *pm=ProcessorsManager::getInstance();
	ProcessingUnit *pu=pm->getProcessor(0);
	for (int i=0; i<10000; i++){
		pu=pm->getProcessor(i);
		pu->execute(new A());
	}
	pm->join();

	return 0;
}

